/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: array.h,v 1.2 2000/11/14 15:56:26 takayuki Exp $
 */

//----------------------------------------------------------------
// class array - class definition
//

#ifndef __ARRAY_H
#define __ARRAY_H

#include <vector>
#include "valient.h"

class Array
{
public:
	enum tagType
	{
		EMPTY, ARRAY, VALUE
	};

protected:
	struct tagValue
	{
		enum tagType Type;
		union
		{
			Array * ArrayedValue;
			Valient * SingleValue;
		};
	};

	std::vector<tagValue> Entity;

	bool Grow(unsigned int);
	bool Clear(tagValue *);

public:
	Array(void);
	Array(const Array &);
	virtual ~Array(void);

		//Ϥϥԡ뤬ݥϤϤͤȤ
	bool Set(unsigned int,const Valient &);
	bool Set(unsigned int,Valient *);
	bool Set(unsigned int,const Array &);
	bool Set(unsigned int,Array *);

	Valient * GetValuePtr(unsigned int);
	Array * GetArrayPtr(unsigned int);
	tagType GetType(unsigned int);

	Valient & operator [](unsigned int);

	bool IsArray(unsigned int);
	unsigned int Size(void);

	bool Clear(void);
};

//------------------------------------------------------------
// Inline function declaration

inline Valient & Array::operator [](unsigned int offset)
{
	return *(Entity[offset].SingleValue);
}

inline bool Array::IsArray(unsigned int offset)
{
	if( offset > Entity.size() )
		return false;

	return (Entity[offset].Type == ARRAY);
}

inline unsigned int Array::Size(void)
{	return Entity.size();	}

#endif

//--------
// Designed and Programmed by S.D.F.