/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: debugout.c,v 1.1 2000/11/14 16:31:38 takayuki Exp $
 */
#include "debugout.h"
#include "resource.h"

#ifdef DEBUG_ENABLE

static HANDLE DebugConsole;
static HWND DialogHandle;



LRESULT CALLBACK DebugOutDialogProc(HWND hDlg,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	switch(Msg)
	{
	case WM_INITDIALOG:
		DebugConsole = GetDlgItem(hDlg,IDC_DEBUGOUT);
		ShowWindow(hDlg,SW_SHOW);

	case WM_SIZE:
		{
			RECT client;
			GetClientRect(hDlg,&client);
			MoveWindow(DebugConsole,0,0,client.right,client.bottom,TRUE);
			break;
		}

	case WM_CLOSE:
			/* Closing this dialog is restricted. */
		break;

	case WM_DESTROY:
		DialogHandle = 0;
		break;

	case WM_QUIT:
		DestroyWindow(hDlg);
		break;
	
	default:
		return FALSE;
	}
	return TRUE;
}

void InitializeDebugServices(HINSTANCE hinst,HWND dlg)
{
	int i;
	DialogHandle = CreateDialog(hinst,MAKEINTRESOURCE(DEBUGOUTDIALOG),0l,DebugOutDialogProc);
	i = GetLastError();
	ShowWindow(DialogHandle,SW_SHOW);
}


void FinalizeDebugServices(void)
{
	if(DialogHandle != 0l)
		DestroyWindow(DialogHandle);
}

unsigned int DebugOut(LPCSTR str)
{
	int i,j,k,l;
	char buffer[1024];

	i = GetWindowTextLength(DebugConsole);
	if(i > DEBUG_LIMITTERUPPERBOUND)
	{
		SendMessage(DebugConsole, EM_SETSEL, 0, i - DEBUG_LIMITTERUPPERBOUND);
		SendMessage(DebugConsole, EM_REPLACESEL, (WPARAM)FALSE, (LPARAM)"");
	}

	j = lstrlen(str);
	while(j>0)
	{
		k = j > 512 ? 511 : j;
		for(l=0;l<k;l++,str++)
		{
			if( (buffer[l] = *str) == '\n')
			{
				buffer[l] = '\r';
				buffer[++l] = '\n';
			}
		}
		buffer[l] = '\x0';

		i = GetWindowTextLength(DebugConsole);
		SendMessage(DebugConsole,EM_SETSEL,i,i);
		SendMessage(DebugConsole,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)buffer);
		
		j -= k;
	}
	return 1;


/*
	int i;
	HANDLE mem;
	char * buf;

	i=OpenClipboard(DialogHandle);

	i = lstrlen(str);
	mem = GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,i+1);
	buf = GlobalLock(mem);
	lstrcpyn(buf,str,i+1);
	GlobalUnlock(mem);

	i=SetClipboardData(CF_TEXT,mem);
	CloseClipboard();

	SendMessage(DebugConsole,WM_PASTE,0,0);
	return (unsigned)i;
*/
}


#endif